=== modified file 'NEWS'
--- NEWS	2007-07-30 03:25:03 +0000
+++ NEWS	2007-07-30 17:06:48 +0000
@@ -99,6 +99,11 @@
       the file starts with ``callgrind.out``. This matches the default file
       filtering done by KCacheGrind's Open Dialog. (Ian Clatworthy)
 
+    * Fix ``bzr update`` to avoid an unnecessary
+      ``branch.get_master_branch`` call, which avoids 1 extra connection
+      to the remote server. (Partial fix for #128076, John Arbash Meinel)
+      
+
   LIBRARY API BREAKS:
 
     * Deprecated dictionary ``bzrlib.option.SHORT_OPTIONS`` removed.

=== modified file 'bzrlib/builtins.py'
--- bzrlib/builtins.py	2007-07-26 19:51:56 +0000
+++ bzrlib/builtins.py	2007-07-30 17:05:02 +0000
@@ -1029,7 +1029,6 @@
             if last_rev == _mod_revision.ensure_null(
                 tree.branch.last_revision()):
                 # may be up to date, check master too.
-                master = tree.branch.get_master_branch()
                 if master is None or last_rev == _mod_revision.ensure_null(
                     master.last_revision()):
                     revno = tree.branch.revision_id_to_revno(last_rev)

=== modified file 'bzrlib/smart/protocol.py'
--- bzrlib/smart/protocol.py	2007-07-09 05:56:41 +0000
+++ bzrlib/smart/protocol.py	2007-07-27 19:41:03 +0000
@@ -302,7 +302,7 @@
 
     def call(self, *args):
         if 'hpss' in debug.debug_flags:
-            mutter('hpss call: %r', args)
+            mutter('hpss call:   %r', args)
         self._write_args(args)
         self._request.finished_writing()
 

=== modified file 'bzrlib/transport/remote.py'
--- bzrlib/transport/remote.py	2007-07-20 18:59:29 +0000
+++ bzrlib/transport/remote.py	2007-07-30 14:36:04 +0000
@@ -27,7 +27,9 @@
 import urlparse
 
 from bzrlib import (
+    debug,
     errors,
+    trace,
     transport,
     urlutils,
     )
@@ -105,8 +107,11 @@
             credentials = None
             if medium is None:
                 medium, credentials = self._build_medium()
-            self._shared_connection= transport._SharedConnection(medium,
-                                                                 credentials)
+                if 'hpss' in debug.debug_flags:
+                    trace.mutter('hpss: Built a new medium: %s',
+                                 medium.__class__.__name__)
+            self._shared_connection = transport._SharedConnection(medium,
+                                                                  credentials)
 
         if _client is None:
             self._client = client._SmartClient(self.get_shared_medium())

